#!/etc/opt/openit/perl -w

use strict;


my $cfg = "/var/opt/openit/etc/filtrator/freeze-host-user-usage.conf";
my $old = "$cfg.pre.903";
my $new = "$cfg.new";

# Only root can patch
if ( $< ne 0 ) {
    die "Error: Patching must be done as 'root'!\n";
}

open(IN, "$cfg") || die "Error: Unable to read old cfg '$cfg'!\n";

# Read in existing freeze config
my @lines = <IN>;
close(IN);

my $index = 0;

while($lines[$index] !~ /CalcSum.feature/ ) 
{ 
    $index++;
}

if ( $lines[$index + 2] =~ /Duplicate.all/ ) 
{ 
    print "Update already done, skipping\n";
    exit 0;
}
#add missing objects
splice(@lines, $index + 2, 0,
"									Duplicate:all()=\"\"\
									{
										Duplicate:running()=\"\"
										{
");


#add tabs on for layout
$index += 3;
while($lines[$index] !~ /.*filter.defs.*/)
{
	$lines[$index] = "\t\t$lines[$index]" ;
	$index++;
}

# add close brace for added configuration
splice(@lines, $index, 0, "\t\t}\n\t}\n" );


while ($lines[$index] !~ /.*CalcSum.product.*/ )
{
	$index++;
}

splice(@lines, $index, 0, 
"		Duplicate:all()=\"\"
		{
			inactive(Bool)=\"false\"{}
			filter(String)=\"Duplicate\"{}
			limited()=\"\"
			{
				simple(String)=\"0=All,2=All,11=All,12=All\"{}
				source(String)=\"disable\"{}
				target(String)=\"disable\"{}
			}
		}
		Duplicate:running()=\"\"
		{
			inactive(Bool)=\"false\"{}
			filter(String)=\"Duplicate\"{}
			limited()=\"\"
			{
				simple(String)=\"0=Running,2=Running\"{}
				source(String)=\"disable\"{}
				target(String)=\"disable\"{}
			}
		}
" );



# Write new freeze host user config 
open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
print OUT @lines;
close(OUT);

if( ! rename($cfg, $old)) {
    die "Error: Unable to previous config to '$old'!\n";
}

if( ! rename($new, $cfg)) {
    die "Error: Unable to rename new config to '$cfg'!\n";
}

exit 0;
